
;CodeVisionAVR C Compiler V1.25.9 Professional
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 19,680000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : Off

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "main.vec"
	.INCLUDE "main.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 Project    : IO-050 PPS Breakout Box
;       3 Version    : 0.1
;       4 Date       : --.11.2008
;       5 
;       6 
;       7 Chip type           : ATmega16
;       8 Program type        : Application
;       9 Clock frequency     : 19,680000 MHz
;      10 Memory model        : Small
;      11 External SRAM size  : 0
;      12 Data Stack size     : 256
;      13 *****************************************************/
;      14 
;      15 #include <mega16.H>
;      16 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      17 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      18 	.EQU __se_bit=0x40
	.EQU __se_bit=0x40
;      19 	.EQU __sm_mask=0xB0
	.EQU __sm_mask=0xB0
;      20 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      21 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      22 	.EQU __sm_standby=0xA0
	.EQU __sm_standby=0xA0
;      23 	.EQU __sm_ext_standby=0xB0
	.EQU __sm_ext_standby=0xB0
;      24 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      25 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      26 	#endif
	#endif
;      27 #include <delay.h>
;      28 
;      29 #define A0 PORTB.0
;      30 #define A1 PORTB.1
;      31 #define A2 PORTB.2
;      32 
;      33 #define H_PPS PORTB.3
;      34 #define M_PPS PORTB.4
;      35 #define PPS PIND.2
;      36 
;      37 #define BUTTON PIND.6
;      38 #define HOLD 100
;      39 
;      40 char i, k; //i -   , k -     
_i:
	.BYTE 0x1
_k:
	.BYTE 0x1
;      41 
;      42 void __io_init () //  /
;      43 {

	.CSEG
___io_init:
;      44 DDRA = 0b000; //  
	LDI  R30,LOW(0)
	OUT  0x1A,R30
;      45 PORTA = 0b111;
	LDI  R30,LOW(7)
	OUT  0x1B,R30
;      46 
;      47 DDRB = 0b00011111; //PB0 - PB4 - : PB0-PB2 - , PB3 - , PB4 -  pps,    
	LDI  R30,LOW(31)
	OUT  0x17,R30
;      48 PORTB = 0b11101000; // "28 "
	LDI  R30,LOW(232)
	OUT  0x18,R30
;      49 
;      50 DDRD = 0b0000000; //  
	LDI  R30,LOW(0)
	OUT  0x11,R30
;      51 PORTD = 0b1111111;
	LDI  R30,LOW(127)
	OUT  0x12,R30
;      52 
;      53 // Analog Comparator initialization
;      54 // Analog Comparator: Off
;      55 // Analog Comparator Input Capture by Timer/Counter 1: Off
;      56 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;      57 }
	RET
;      58 
;      59 char __routine (char x) //  
;      60 {
___routine:
;      61 
;      62 char k_l; //k_l-     
;      63 
;      64 switch (x)
	ST   -Y,R17
;	x -> Y+1
;	k_l -> R17
	LDD  R30,Y+1
;      65        {
;      66         case 0: H_PPS = 1; //  -  
	CPI  R30,0
	BRNE _0x6
	SBI  0x18,3
;      67 
;      68 		        A0 = 0; //
	CBI  0x18,0
;      69 		        A1 = 0;
	CBI  0x18,1
;      70 				A2 = 0;
	CBI  0x18,2
;      71 		break;
	RJMP _0x5
;      72 
;      73 		case 1: H_PPS = 1;
_0x6:
	CPI  R30,LOW(0x1)
	BRNE _0xF
	SBI  0x18,3
;      74 
;      75 		        A0 = 1;
	SBI  0x18,0
;      76 		        A1 = 0;
	CBI  0x18,1
;      77 				A2 = 0;
	CBI  0x18,2
;      78 		break;
	RJMP _0x5
;      79 
;      80 		case 2: H_PPS = 1;
_0xF:
	CPI  R30,LOW(0x2)
	BRNE _0x18
	SBI  0x18,3
;      81 
;      82 		        A0 = 0;
	CBI  0x18,0
;      83 		        A1 = 1;
	SBI  0x18,1
;      84 				A2 = 0;
	CBI  0x18,2
;      85 		break;
	RJMP _0x5
;      86 
;      87 		case 3: H_PPS = 1;
_0x18:
	CPI  R30,LOW(0x3)
	BRNE _0x21
	SBI  0x18,3
;      88 
;      89 				A0 = 1;
	SBI  0x18,0
;      90 		        A1 = 1;
	SBI  0x18,1
;      91 				A2 = 0;
	CBI  0x18,2
;      92 		break;
	RJMP _0x5
;      93 
;      94 		case 4: H_PPS = 1;
_0x21:
	CPI  R30,LOW(0x4)
	BRNE _0x2A
	SBI  0x18,3
;      95 
;      96 				A0 = 0;
	CBI  0x18,0
;      97 		        A1 = 0;
	CBI  0x18,1
;      98 				A2 = 1;
	SBI  0x18,2
;      99 		break;
	RJMP _0x5
;     100 
;     101 		case 5: H_PPS = 1;
_0x2A:
	CPI  R30,LOW(0x5)
	BRNE _0x33
	SBI  0x18,3
;     102 
;     103 				A0 = 1;
	SBI  0x18,0
;     104 		        A1 = 0;
	CBI  0x18,1
;     105 				A2 = 1;
	SBI  0x18,2
;     106 		break;
	RJMP _0x5
;     107 
;     108 		case 6: H_PPS = 1;
_0x33:
	CPI  R30,LOW(0x6)
	BRNE _0x3C
	SBI  0x18,3
;     109 
;     110 				A0 = 0;
	CBI  0x18,0
;     111 		        A1 = 1;
	SBI  0x18,1
;     112 				A2 = 1;
	SBI  0x18,2
;     113 		break;
	RJMP _0x5
;     114 
;     115 		case 7: H_PPS = 1;
_0x3C:
	CPI  R30,LOW(0x7)
	BRNE _0x45
	SBI  0x18,3
;     116 
;     117 		        A0 = 1;
	SBI  0x18,0
;     118 		        A1 = 1;
	SBI  0x18,1
;     119 				A2 = 1;
	SBI  0x18,2
;     120 		break;
	RJMP _0x5
;     121 
;     122 		case 8: H_PPS = 0; //  -   4 
_0x45:
	CPI  R30,LOW(0x8)
	BRNE _0x4E
	CBI  0x18,3
;     123 
;     124 				A0 = 0;
	CBI  0x18,0
;     125 		        A1 = 0;
	CBI  0x18,1
;     126 				A2 = 0;
	CBI  0x18,2
;     127 
;     128 				OCR0=0x4F; //    79 0x4f
	LDI  R30,LOW(79)
	OUT  0x3C,R30
;     129 				k_l = 1; //    19,68 
	LDI  R17,LOW(1)
;     130 		break;
	RJMP _0x5
;     131 
;     132 		case 9: H_PPS = 0; //20 
_0x4E:
	CPI  R30,LOW(0x9)
	BRNE _0x57
	CBI  0x18,3
;     133 
;     134 		        A0 = 1;
	SBI  0x18,0
;     135 		        A1 = 0;
	CBI  0x18,1
;     136 				A2 = 0;
	CBI  0x18,2
;     137 
;     138 				OCR0=0x32; //    50 0x32
	LDI  R30,LOW(50)
	OUT  0x3C,R30
;     139 				k_l = 2; //    19,68/8 
	LDI  R17,LOW(2)
;     140 		break;
	RJMP _0x5
;     141 
;     142 		case 10: H_PPS = 0; //40 
_0x57:
	CPI  R30,LOW(0xA)
	BRNE _0x60
	CBI  0x18,3
;     143 
;     144 		         A0 = 0;
	CBI  0x18,0
;     145 		         A1 = 1;
	SBI  0x18,1
;     146 				 A2 = 0;
	CBI  0x18,2
;     147 
;     148 				 OCR0=0x63; //    99 0x63
	LDI  R30,LOW(99)
	OUT  0x3C,R30
;     149 				 k_l = 2; //    19,68/8 
	LDI  R17,LOW(2)
;     150 		break;
	RJMP _0x5
;     151 
;     152 		case 11: H_PPS = 0; //60 
_0x60:
	CPI  R30,LOW(0xB)
	BRNE _0x69
	CBI  0x18,3
;     153 
;     154 				 A0 = 1;
	SBI  0x18,0
;     155 		         A1 = 1;
	SBI  0x18,1
;     156 				 A2 = 0;
	CBI  0x18,2
;     157 
;     158 				 OCR0=0x94; //    148 0x94
	LDI  R30,LOW(148)
	OUT  0x3C,R30
;     159 				 k_l = 0x02; //    19,68/8 
	LDI  R17,LOW(2)
;     160 		break;
	RJMP _0x5
;     161 
;     162 		case 12: H_PPS = 0; //80 
_0x69:
	CPI  R30,LOW(0xC)
	BRNE _0x72
	CBI  0x18,3
;     163 
;     164 				 A0 = 0;
	CBI  0x18,0
;     165 		         A1 = 0;
	CBI  0x18,1
;     166 				 A2 = 1;
	SBI  0x18,2
;     167 
;     168 				 OCR0=0xC7; //    199 0x7
	LDI  R30,LOW(199)
	OUT  0x3C,R30
;     169 				 k_l = 2; //    19,68/8 
	LDI  R17,LOW(2)
;     170 		break;
	RJMP _0x5
;     171 
;     172 		case 13: H_PPS = 0; //100 
_0x72:
	CPI  R30,LOW(0xD)
	BRNE _0x7B
	CBI  0x18,3
;     173 
;     174 				 A0 = 1;
	SBI  0x18,0
;     175 		         A1 = 0;
	CBI  0x18,1
;     176 				 A2 = 1;
	SBI  0x18,2
;     177 
;     178 				 OCR0=0xF8; //    248 0xF8
	LDI  R30,LOW(248)
	OUT  0x3C,R30
;     179 				 k_l = 2; //    19,68/8 
	LDI  R17,LOW(2)
;     180 		break;
	RJMP _0x5
;     181 
;     182 		case 14: H_PPS = 0; //120 
_0x7B:
	CPI  R30,LOW(0xE)
	BRNE _0x84
	CBI  0x18,3
;     183 
;     184 				 A0 = 0;
	CBI  0x18,0
;     185 		         A1 = 1;
	SBI  0x18,1
;     186 				 A2 = 1;
	SBI  0x18,2
;     187 
;     188 				 OCR0=0x25; //    37 0x25
	LDI  R30,LOW(37)
	RJMP _0xA8
;     189 				 k_l = 3;; //    19,68/64 
;     190 		break;
;     191 
;     192 		case 15: H_PPS = 0; //140 
_0x84:
	CPI  R30,LOW(0xF)
	BRNE _0x5
	CBI  0x18,3
;     193 
;     194 		         A0 = 1;
	SBI  0x18,0
;     195 		         A1 = 1;
	SBI  0x18,1
;     196 				 A2 = 1;
	SBI  0x18,2
;     197 
;     198 				 OCR0=0x2B; //    43 0x2B
	LDI  R30,LOW(43)
_0xA8:
	OUT  0x3C,R30
;     199 				 k_l = 3;; //    19,68/64 
	LDI  R17,LOW(3)
;     200 		break;
;     201 		};
_0x5:
;     202 
;     203 return k_l;
	MOV  R30,R17
	LDD  R17,Y+0
	ADIW R28,2
	RET
;     204 }
;     205 
;     206 void __interrupt_initialization ()
;     207 {
___interrupt_initialization:
;     208 // External Interrupt(s) initialization
;     209 // INT0: On
;     210 // INT0 Mode: Any change
;     211 // INT1: Off
;     212 // INT2: Off
;     213 GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
;     214 MCUCR=0x01;
	LDI  R30,LOW(1)
	OUT  0x35,R30
;     215 MCUCSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x34,R30
;     216 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     217 
;     218 // Timer(s)/Counter(s) Interrupt(s) initialization
;     219 TIMSK=0x02;
	LDI  R30,LOW(2)
	OUT  0x39,R30
;     220 }
	RET
;     221 
;     222 
;     223 // External Interrupt 0 service routine
;     224 interrupt [EXT_INT0] void __ext_int0_isr(void)
;     225 {
___ext_int0_isr:
	ST   -Y,R30
;     226  TCNT0=0x00; // 
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     227  TCCR0 = k; //    
	LDS  R30,_k
	OUT  0x33,R30
;     228 }
	LD   R30,Y+
	RETI
;     229 
;     230 // Timer 0 output compare interrupt service routine
;     231 interrupt [TIM0_COMP] void __timer0_comp_isr(void)
;     232 {
___timer0_comp_isr:
;     233  M_PPS = PPS;
	SBIC 0x10,2
	RJMP _0x96
	CBI  0x18,4
	RJMP _0x97
_0x96:
	SBI  0x18,4
_0x97:
;     234 }
	RETI
;     235 
;     236 void main ()
;     237 {
_main:
;     238 __io_init (); // /   0- 
	RCALL ___io_init
;     239 
;     240 __interrupt_initialization (); //  INT0
	RCALL ___interrupt_initialization
;     241 
;     242 while (1)
_0x98:
;     243       {
;     244 	   if (!BUTTON) //  
	SBIC 0x10,6
	RJMP _0x9B
;     245 	      {
;     246 		   #asm("cli") //   
	cli
;     247 
;     248 		   i++; // 
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
;     249 
;     250 		   if (i == 16) // 16,   0- 
	LDS  R26,_i
	CPI  R26,LOW(0x10)
	BRNE _0x9C
;     251 		      {
;     252 			   i = 0;
	LDI  R30,LOW(0)
	STS  _i,R30
;     253 			   };
_0x9C:
;     254 
;     255 		   if (i == 0) //  - M_PPS  z 
	LDS  R30,_i
	CPI  R30,0
	BRNE _0x9D
;     256 		      {
;     257 			   DDRB.4 = 0;
	CBI  0x17,4
;     258 			   };
_0x9D:
;     259 
;     260 		   if (i == 8) //  - M_PPS - 
	LDS  R26,_i
	CPI  R26,LOW(0x8)
	BRNE _0xA0
;     261 		      {
;     262 			   DDRB.4 = 1;
	SBI  0x17,4
;     263 			   };
_0xA0:
;     264 
;     265 		   k = __routine (i); // 
	LDS  R30,_i
	ST   -Y,R30
	RCALL ___routine
	STS  _k,R30
;     266 
;     267 		   if (i > 7) //  
	LDS  R26,_i
	CPI  R26,LOW(0x8)
	BRLO _0xA3
;     268 		      {
;     269 			   #asm ("sei") //  
	sei
;     270 			   };
_0xA3:
;     271 
;     272 		   while (!BUTTON)
_0xA4:
	SBIC 0x10,6
	RJMP _0xA6
;     273 		         { //  
;     274                   delay_ms (HOLD);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     275                   };
	RJMP _0xA4
_0xA6:
;     276            };
_0x9B:
;     277 
;     278 	   };
	JMP  _0x98
;     279 }
_0xA7:
	RJMP _0xA7


_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x1338
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

;END OF CODE MARKER
__END_OF_CODE:
