/*****************************************************
Project    : IO-050 PPS Breakout Box
Version    : 0.1
Date       : --.11.2008


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 19,680000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega16


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-





char i, k; //i -   , k -     

void __io_init () //  /
{
DDRA = 0b000; //  
PORTA = 0b111;

DDRB = 0b00011111; //PB0 - PB4 - : PB0-PB2 - , PB3 - , PB4 -  pps,    
PORTB = 0b11101000; // "28 " 

DDRD = 0b0000000; //  
PORTD = 0b1111111;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
}

char __routine (char x) //  
{

char k_l; //k_l-     

switch (x)
       {
        case 0: PORTB.3 = 1; //  -  
		
		        PORTB.0 = 0; //
		        PORTB.1 = 0;
				PORTB.2 = 0;
		break;
		
		case 1: PORTB.3 = 1;
		
		        PORTB.0 = 1;
		        PORTB.1 = 0;
				PORTB.2 = 0;
		break;
		
		case 2: PORTB.3 = 1;
		
		        PORTB.0 = 0;
		        PORTB.1 = 1;
				PORTB.2 = 0;
		break;
		
		case 3: PORTB.3 = 1;
		        
				PORTB.0 = 1;
		        PORTB.1 = 1;
				PORTB.2 = 0;
		break;
		
		case 4: PORTB.3 = 1;
		        
				PORTB.0 = 0;
		        PORTB.1 = 0;
				PORTB.2 = 1;
		break;
		
		case 5: PORTB.3 = 1;
		        
				PORTB.0 = 1;
		        PORTB.1 = 0;
				PORTB.2 = 1;
		break;
		
		case 6: PORTB.3 = 1;
		        
				PORTB.0 = 0;
		        PORTB.1 = 1;
				PORTB.2 = 1;
		break;
		
		case 7: PORTB.3 = 1;
		
		        PORTB.0 = 1;
		        PORTB.1 = 1;
				PORTB.2 = 1;
		break;
		
		case 8: PORTB.3 = 0; //  -   4 
		        
				PORTB.0 = 0; 
		        PORTB.1 = 0;
				PORTB.2 = 0;
				
				OCR0=0x4F; //    79 0x4f
				k_l = 1; //    19,68 
		break;
		
		case 9: PORTB.3 = 0; //20 
		
		        PORTB.0 = 1;
		        PORTB.1 = 0;
				PORTB.2 = 0;
				
				OCR0=0x32; //    50 0x32
				k_l = 2; //    19,68/8 
		break;
		
		case 10: PORTB.3 = 0; //40 
		
		         PORTB.0 = 0;
		         PORTB.1 = 1;
				 PORTB.2 = 0;

				 OCR0=0x63; //    99 0x63
				 k_l = 2; //    19,68/8  
		break;
		
		case 11: PORTB.3 = 0; //60 
		        
				 PORTB.0 = 1;
		         PORTB.1 = 1;
				 PORTB.2 = 0;

				 OCR0=0x94; //    148 0x94
				 k_l = 0x02; //    19,68/8  
		break;
		
		case 12: PORTB.3 = 0; //80 
		        
				 PORTB.0 = 0;
		         PORTB.1 = 0;
				 PORTB.2 = 1;

				 OCR0=0xC7; //    199 0x7
				 k_l = 2; //    19,68/8  
		break;

		case 13: PORTB.3 = 0; //100 
		        
				 PORTB.0 = 1;
		         PORTB.1 = 0;
				 PORTB.2 = 1;

				 OCR0=0xF8; //    248 0xF8
				 k_l = 2; //    19,68/8  
		break;

		case 14: PORTB.3 = 0; //120 
		        
				 PORTB.0 = 0;
		         PORTB.1 = 1;
				 PORTB.2 = 1;

				 OCR0=0x25; //    37 0x25
				 k_l = 3;; //    19,68/64  
		break;

		case 15: PORTB.3 = 0; //140 
		
		         PORTB.0 = 1;
		         PORTB.1 = 1;
				 PORTB.2 = 1;

				 OCR0=0x2B; //    43 0x2B
				 k_l = 3;; //    19,68/64  
		break;
		};

return k_l;		
}
		
void __interrupt_initialization ()
{
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Any change
// INT1: Off
// INT2: Off
GICR|=0x40;
MCUCR=0x01;
MCUCSR=0x00;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x02;
}


// External Interrupt 0 service routine
interrupt [2] void __ext_int0_isr(void)
{
 TCNT0=0x00; // 
 TCCR0 = k; //    
}

// Timer 0 output compare interrupt service routine
interrupt [20] void __timer0_comp_isr(void)
{
 PORTB.4 = PIND.2;
}

void main ()
{
__io_init (); // /   0- 

__interrupt_initialization (); //  INT0

while (1)
      {
	   if (!PIND.6) //  
	      {
		   #asm("cli") //   
		   
		   i++; // 
		   
		   if (i == 16) // 16,   0- 
		      {
			   i = 0;
			   };
		   
		   if (i == 0) //  - M_PPS  z 
		      {
			   DDRB.4 = 0;
			   };
		   
		   if (i == 8) //  - M_PPS - 
		      {
			   DDRB.4 = 1;
			   };
		   
		   k = __routine (i); // 
           
		   if (i > 7) //  
		      {
			   #asm ("sei") //  
			   };
			   
		   while (!PIND.6)
		         { //  
                  delay_ms (100);
                  };
           };				  
	   
	   };
}
