/*****************************************************
Project    : IO-050 PPS Breakout Box
Version    : 0.1
Date       : --.11.2008


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 19,680000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega16.H>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>

#define A0 PORTB.0
#define A1 PORTB.1
#define A2 PORTB.2

#define H_PPS PORTB.3
#define M_PPS PORTB.4
#define PPS PIND.2

#define BUTTON PIND.6
#define HOLD 100

char i, k; //i -   , k -     

void __io_init () //  /
{
DDRA = 0b000; //  
PORTA = 0b111;

DDRB = 0b00011111; //PB0 - PB4 - : PB0-PB2 - , PB3 - , PB4 -  pps,    
PORTB = 0b11101000; // "28 "

DDRD = 0b0000000; //  
PORTD = 0b1111111;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
}

char __routine (char x) //  
{

char k_l; //k_l-     

switch (x)
       {
        case 0: H_PPS = 1; //  -  

		        A0 = 0; //
		        A1 = 0;
				A2 = 0;
		break;

		case 1: H_PPS = 1;

		        A0 = 1;
		        A1 = 0;
				A2 = 0;
		break;

		case 2: H_PPS = 1;

		        A0 = 0;
		        A1 = 1;
				A2 = 0;
		break;

		case 3: H_PPS = 1;

				A0 = 1;
		        A1 = 1;
				A2 = 0;
		break;

		case 4: H_PPS = 1;

				A0 = 0;
		        A1 = 0;
				A2 = 1;
		break;

		case 5: H_PPS = 1;

				A0 = 1;
		        A1 = 0;
				A2 = 1;
		break;

		case 6: H_PPS = 1;

				A0 = 0;
		        A1 = 1;
				A2 = 1;
		break;

		case 7: H_PPS = 1;

		        A0 = 1;
		        A1 = 1;
				A2 = 1;
		break;

		case 8: H_PPS = 0; //  -   4 

				A0 = 0;
		        A1 = 0;
				A2 = 0;

				OCR0=0x4F; //    79 0x4f
				k_l = 1; //    19,68 
		break;

		case 9: H_PPS = 0; //20 

		        A0 = 1;
		        A1 = 0;
				A2 = 0;

				OCR0=0x32; //    50 0x32
				k_l = 2; //    19,68/8 
		break;

		case 10: H_PPS = 0; //40 

		         A0 = 0;
		         A1 = 1;
				 A2 = 0;

				 OCR0=0x63; //    99 0x63
				 k_l = 2; //    19,68/8 
		break;

		case 11: H_PPS = 0; //60 

				 A0 = 1;
		         A1 = 1;
				 A2 = 0;

				 OCR0=0x94; //    148 0x94
				 k_l = 0x02; //    19,68/8 
		break;

		case 12: H_PPS = 0; //80 

				 A0 = 0;
		         A1 = 0;
				 A2 = 1;

				 OCR0=0xC7; //    199 0x7
				 k_l = 2; //    19,68/8 
		break;

		case 13: H_PPS = 0; //100 

				 A0 = 1;
		         A1 = 0;
				 A2 = 1;

				 OCR0=0xF8; //    248 0xF8
				 k_l = 2; //    19,68/8 
		break;

		case 14: H_PPS = 0; //120 

				 A0 = 0;
		         A1 = 1;
				 A2 = 1;

				 OCR0=0x25; //    37 0x25
				 k_l = 3;; //    19,68/64 
		break;

		case 15: H_PPS = 0; //140 

		         A0 = 1;
		         A1 = 1;
				 A2 = 1;

				 OCR0=0x2B; //    43 0x2B
				 k_l = 3;; //    19,68/64 
		break;
		};

return k_l;
}

void __interrupt_initialization ()
{
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Any change
// INT1: Off
// INT2: Off
GICR|=0x40;
MCUCR=0x01;
MCUCSR=0x00;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x02;
}


// External Interrupt 0 service routine
interrupt [EXT_INT0] void __ext_int0_isr(void)
{
 TCNT0=0x00; // 
 TCCR0 = k; //    
}

// Timer 0 output compare interrupt service routine
interrupt [TIM0_COMP] void __timer0_comp_isr(void)
{
 M_PPS = PPS;
}

void main ()
{
__io_init (); // /   0- 

__interrupt_initialization (); //  INT0

while (1)
      {
	   if (!BUTTON) //  
	      {
		   #asm("cli") //   

		   i++; // 

		   if (i == 16) // 16,   0- 
		      {
			   i = 0;
			   };

		   if (i == 0) //  - M_PPS  z 
		      {
			   DDRB.4 = 0;
			   };

		   if (i == 8) //  - M_PPS - 
		      {
			   DDRB.4 = 1;
			   };

		   k = __routine (i); // 

		   if (i > 7) //  
		      {
			   #asm ("sei") //  
			   };

		   while (!BUTTON)
		         { //  
                  delay_ms (HOLD);
                  };
           };

	   };
}
